=== debian/changelog ===
jas (2.7.200-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * liblog4j1.2-java -> liblog4j2-java
  * Deal with restricted type name

 -- Andreas Tille <tille@debian.org>  Tue, 28 Jan 2025 15:41:32 +0100

jas (2.5.4408-2) unstable; urgency=medium

  * Team upload.

  [ Giovanni Mascellani ]
  * Fix watch file

  [ Andreas Tille ]
  * Secure URI in Homepage
  * d/copyright: Fix Source URL
  * Build-Depends: s/default-jdk/default-jdk-headless/
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add missing build dependency on javahelper for addon javahelper.
  * Prevent potential privacy breach
  * Rename debian/TODO.Debian to debian/TODO

 -- Andreas Tille <tille@debian.org>  Tue, 28 Jan 2025 15:21:31 +0100
