=== debian/control ===
Source: jas
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Giovanni Mascellani <gio@debian.org>
Section: java
Priority: optional
Build-Depends: debhelper-compat (= 13),
               default-jdk-headless,
               liblog4j2-java,
               junit4,
               javahelper
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/java-team/jas
Vcs-Git: https://salsa.debian.org/java-team/jas.git
Homepage: https://krum.rz.uni-mannheim.de/jas/

Package: libjas-java
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${java:Depends}
Description: Java object-oriented type-safe Algebra System
 Java Algebra System (JAS) is an object-oriented, type-safe and
 multi-threaded library using generic types for algebraic
 computations. It mainly focuses on commutative algebra, solvable
 polynomials, Groebner bases, factorization, power series and real
 roots.
